# Code for Hands-on Unsupervised Learning Using Python: How to Build Applied Machine Learning Solutions from Unlabeled Data (O'Reilly Media, Inc.)

Available on Amazon: https://www.amazon.com/Hands-Unsupervised-Learning-Using-Python/dp/1492035645

Available on O'Reilly Safari: https://www.oreilly.com/library/view/hands-on-unsupervised-learning/9781492035633/

Book Description

Many industry experts consider unsupervised learning the next frontier in artificial intelligence, one that may hold the key to the holy grail in AI research, the so-called general artificial intelligence. Since the majority of the world's data is unlabeled, conventional supervised learning cannot be applied; this is where unsupervised learning comes in. Unsupervised learning can be applied to unlabeled datasets to discover meaningful patterns buried deep in the data, patterns that may be near impossible for humans to uncover.

Author Ankur Patel provides practical knowledge on how to apply unsupervised learning using two simple, production-ready Python frameworks - scikit-learn and TensorFlow using Keras. With the hands-on examples and code provided, you will identify difficult-to-find patterns in data and gain deeper business insight, detect anomalies, perform automatic feature engineering and selection, and generate synthetic datasets. All you need is programming and some machine learning experience to get started.

* Compare the strengths and weaknesses of the different machine learning approaches: supervised, unsupervised, and reinforcement learning
* Set up and manage a machine learning project end-to-end - everything from data acquisition to building a model and implementing a solution in production
* Use dimensionality reduction algorithms to uncover the most relevant information in data and build an anomaly detection system to catch credit card fraud
* Apply clustering algorithms to segment users - such as loan borrowers - into distinct and homogeneous groups
* Use autoencoders to perform automatic feature engineering and selection
* Combine supervised and unsupervised learning algorithms to develop semi-supervised solutions
* Build movie recommender systems using restricted Boltzmann machines
* Generate synthetic images using deep belief networks and generative adversarial networks
* Perform clustering on time series data such as electrocardiograms
* Explore the successes of unsupervised learning to date and its promising future
